# Go API client for swagger

API for DiscoverSnoop Service

## Overview
This API client was generated by the [swagger-codegen](https://github.com/swagger-api/swagger-codegen) project.  By using the [swagger-spec](https://github.com/swagger-api/swagger-spec) from a remote server, you can easily generate an API client.

- API version: 0.9.250210
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.go.GoClientCodegen

## Installation
Put the package under your project folder and add the following in import:
```golang
import "./swagger"
```

## Documentation for API Endpoints

All URIs are relative to *https://api.discoversnoop.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AlertsApi* | [**AlertsChangeGet**](docs/AlertsApi.md#alertschangeget) | **Get** /alerts_change | Edit or insert new alert
*AlertsApi* | [**AlertsDeleteGet**](docs/AlertsApi.md#alertsdeleteget) | **Get** /alerts_delete | Permanently delete the alert
*AlertsApi* | [**AlertsGet**](docs/AlertsApi.md#alertsget) | **Get** /alerts | Get alerts for user account
*FavsApi* | [**FavsAddGet**](docs/FavsApi.md#favsaddget) | **Get** /favs_add | Create a new fav
*FavsApi* | [**FavsDeleteGet**](docs/FavsApi.md#favsdeleteget) | **Get** /favs_delete | Permanently delete the fav
*FavsApi* | [**FavsGet**](docs/FavsApi.md#favsget) | **Get** /favs | Get favorites
*FavsApi* | [**FavsUpdateGet**](docs/FavsApi.md#favsupdateget) | **Get** /favs_update | Update the fav
*HistoricalApi* | [**CategoriesGet**](docs/HistoricalApi.md#categoriesget) | **Get** /categories | Get historical stats for categories
*HistoricalApi* | [**CategoryGet**](docs/HistoricalApi.md#categoryget) | **Get** /category | Get history for category ID
*HistoricalApi* | [**DomainGet**](docs/HistoricalApi.md#domainget) | **Get** /domain | Get history for domain name
*HistoricalApi* | [**DomainsGet**](docs/HistoricalApi.md#domainsget) | **Get** /domains | Get historical stats for domains
*HistoricalApi* | [**EntitiesGet**](docs/HistoricalApi.md#entitiesget) | **Get** /entities | Get historical stats for entities
*HistoricalApi* | [**EntityGet**](docs/HistoricalApi.md#entityget) | **Get** /entity | Get history for entity
*HistoricalApi* | [**PageGet**](docs/HistoricalApi.md#pageget) | **Get** /page | Get page history for URL
*HistoricalApi* | [**PagesGet**](docs/HistoricalApi.md#pagesget) | **Get** /pages | Get historical stats for pages
*InfoApi* | [**CategoriesListGet**](docs/InfoApi.md#categorieslistget) | **Get** /categories_list | Get list of categories used in the product
*InfoApi* | [**CountriesListGet**](docs/InfoApi.md#countrieslistget) | **Get** /countries_list | Get list of countries available in the product
*KbApi* | [**KbArticlesGet**](docs/KbApi.md#kbarticlesget) | **Get** /kb_articles | Get knowledge base articles
*LiveApi* | [**LivecategoriesGet**](docs/LiveApi.md#livecategoriesget) | **Get** /livecategories | Get livedata stats for categories
*LiveApi* | [**LivedomainsGet**](docs/LiveApi.md#livedomainsget) | **Get** /livedomains | Get livedata stats for domains
*LiveApi* | [**LiveentitiesGet**](docs/LiveApi.md#liveentitiesget) | **Get** /liveentities | Get livedata stats for entities
*LiveApi* | [**LivepagesGet**](docs/LiveApi.md#livepagesget) | **Get** /livepages | Get livedata stats for pages
*UserApi* | [**UserCountriesChangeGet**](docs/UserApi.md#usercountrieschangeget) | **Get** /user_countries_change | Change user&#x27;s activated countries
*UserApi* | [**UserCustidChangeGet**](docs/UserApi.md#usercustidchangeget) | **Get** /user_custid_change | Change user customer id. This function is system reserved
*UserApi* | [**UserDeleteGet**](docs/UserApi.md#userdeleteget) | **Get** /user_delete | Permanently delete the user
*UserApi* | [**UserDetailsChangeGet**](docs/UserApi.md#userdetailschangeget) | **Get** /user_details_change | Change user details
*UserApi* | [**UserLoginGet**](docs/UserApi.md#userloginget) | **Get** /user_login | Login user with his credentials
*UserApi* | [**UserMessagesGet**](docs/UserApi.md#usermessagesget) | **Get** /user_messages | Get messages for user
*UserApi* | [**UserPasswordChangeGet**](docs/UserApi.md#userpasswordchangeget) | **Get** /user_password_change | Change user password
*UserApi* | [**UserPasswordResetGet**](docs/UserApi.md#userpasswordresetget) | **Get** /user_password_reset | Reset user password
*UserApi* | [**UserRefreshSubscriptionGet**](docs/UserApi.md#userrefreshsubscriptionget) | **Get** /user_refresh_subscription | Refresh user rights with his Customer ID. This function is system reserved
*UserApi* | [**UserRegisterGet**](docs/UserApi.md#userregisterget) | **Get** /user_register | Login user with his credentials

## Documentation For Models

 - [AlertCollection](docs/AlertCollection.md)
 - [Alerts](docs/Alerts.md)
 - [Categories](docs/Categories.md)
 - [CategoriesCollection](docs/CategoriesCollection.md)
 - [CategoriesList](docs/CategoriesList.md)
 - [CategoriesListCollection](docs/CategoriesListCollection.md)
 - [Category](docs/Category.md)
 - [CountriesList](docs/CountriesList.md)
 - [CountriesListCollection](docs/CountriesListCollection.md)
 - [DistributionCollection](docs/DistributionCollection.md)
 - [Domain](docs/Domain.md)
 - [Domains](docs/Domains.md)
 - [DomainsCollection](docs/DomainsCollection.md)
 - [Entities](docs/Entities.md)
 - [EntitiesCollection](docs/EntitiesCollection.md)
 - [Entity](docs/Entity.md)
 - [Favs](docs/Favs.md)
 - [FavsCollection](docs/FavsCollection.md)
 - [Kb](docs/Kb.md)
 - [KbCollection](docs/KbCollection.md)
 - [Message](docs/Message.md)
 - [MessageCollection](docs/MessageCollection.md)
 - [MetricsCollection](docs/MetricsCollection.md)
 - [Page](docs/Page.md)
 - [Pages](docs/Pages.md)
 - [PagesCollection](docs/PagesCollection.md)
 - [TransactionInfo](docs/TransactionInfo.md)
 - [UserCollection](docs/UserCollection.md)
 - [UserInfo](docs/UserInfo.md)

## Documentation For Authorization

## bearerAuth

## Author


