
/*
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * API version: 0.9.250210
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package swagger

import (
	"context"
	"io/ioutil"
	"net/http"
	"net/url"
	"strings"
	"github.com/antihax/optional"
)

// Linger please
var (
	_ context.Context
)

type HistoricalApiService service
/*
HistoricalApiService Get historical stats for categories
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param country ISO_3166 country code in 2 letters
 * @param optional nil or *HistoricalApiCategoriesGetOpts - Optional Parameters:
     * @param "Subcountry" (optional.String) -  state code
     * @param "FromDate" (optional.String) -  Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param "ToDate" (optional.String) -  Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param "KeywordFilter" (optional.String) -  Filter answers to cateogry names containing a particular keyword
     * @param "Lines" (optional.Int32) -  Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more)
     * @param "Offset" (optional.Int32) -  Get paginated results from X offset
@return []Categories
*/

type HistoricalApiCategoriesGetOpts struct {
    Subcountry optional.String
    FromDate optional.String
    ToDate optional.String
    KeywordFilter optional.String
    Lines optional.Int32
    Offset optional.Int32
}

func (a *HistoricalApiService) CategoriesGet(ctx context.Context, country string, localVarOptionals *HistoricalApiCategoriesGetOpts) ([]Categories, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Get")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue []Categories
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/categories"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	localVarQueryParams.Add("country", parameterToString(country, ""))
	if localVarOptionals != nil && localVarOptionals.Subcountry.IsSet() {
		localVarQueryParams.Add("subcountry", parameterToString(localVarOptionals.Subcountry.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.FromDate.IsSet() {
		localVarQueryParams.Add("from_date", parameterToString(localVarOptionals.FromDate.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.ToDate.IsSet() {
		localVarQueryParams.Add("to_date", parameterToString(localVarOptionals.ToDate.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.KeywordFilter.IsSet() {
		localVarQueryParams.Add("keyword_filter", parameterToString(localVarOptionals.KeywordFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Lines.IsSet() {
		localVarQueryParams.Add("lines", parameterToString(localVarOptionals.Lines.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Offset.IsSet() {
		localVarQueryParams.Add("offset", parameterToString(localVarOptionals.Offset.Value(), ""))
	}
	// to determine the Content-Type header
	localVarHttpContentTypes := []string{}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		if localVarHttpResponse.StatusCode == 200 {
			var v []Categories
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}
/*
HistoricalApiService Get history for category ID
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param id category id
 * @param country ISO_3166 country code in 2 letters
 * @param optional nil or *HistoricalApiCategoryGetOpts - Optional Parameters:
     * @param "Subcountry" (optional.String) -  state code
     * @param "FromDate" (optional.String) -  Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param "ToDate" (optional.String) -  Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
@return []Category
*/

type HistoricalApiCategoryGetOpts struct {
    Subcountry optional.String
    FromDate optional.String
    ToDate optional.String
}

func (a *HistoricalApiService) CategoryGet(ctx context.Context, id string, country string, localVarOptionals *HistoricalApiCategoryGetOpts) ([]Category, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Get")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue []Category
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/category"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	localVarQueryParams.Add("id", parameterToString(id, ""))
	localVarQueryParams.Add("country", parameterToString(country, ""))
	if localVarOptionals != nil && localVarOptionals.Subcountry.IsSet() {
		localVarQueryParams.Add("subcountry", parameterToString(localVarOptionals.Subcountry.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.FromDate.IsSet() {
		localVarQueryParams.Add("from_date", parameterToString(localVarOptionals.FromDate.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.ToDate.IsSet() {
		localVarQueryParams.Add("to_date", parameterToString(localVarOptionals.ToDate.Value(), ""))
	}
	// to determine the Content-Type header
	localVarHttpContentTypes := []string{}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		if localVarHttpResponse.StatusCode == 200 {
			var v []Category
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}
/*
HistoricalApiService Get history for domain name
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param domain domain name (no subdomain allowed)
 * @param country ISO_3166 country code in 2 letters
 * @param optional nil or *HistoricalApiDomainGetOpts - Optional Parameters:
     * @param "Subcountry" (optional.String) -  state code
     * @param "FromDate" (optional.String) -  Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param "ToDate" (optional.String) -  Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
@return []Domain
*/

type HistoricalApiDomainGetOpts struct {
    Subcountry optional.String
    FromDate optional.String
    ToDate optional.String
}

func (a *HistoricalApiService) DomainGet(ctx context.Context, domain string, country string, localVarOptionals *HistoricalApiDomainGetOpts) ([]Domain, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Get")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue []Domain
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/domain"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	localVarQueryParams.Add("domain", parameterToString(domain, ""))
	localVarQueryParams.Add("country", parameterToString(country, ""))
	if localVarOptionals != nil && localVarOptionals.Subcountry.IsSet() {
		localVarQueryParams.Add("subcountry", parameterToString(localVarOptionals.Subcountry.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.FromDate.IsSet() {
		localVarQueryParams.Add("from_date", parameterToString(localVarOptionals.FromDate.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.ToDate.IsSet() {
		localVarQueryParams.Add("to_date", parameterToString(localVarOptionals.ToDate.Value(), ""))
	}
	// to determine the Content-Type header
	localVarHttpContentTypes := []string{}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		if localVarHttpResponse.StatusCode == 200 {
			var v []Domain
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}
/*
HistoricalApiService Get historical stats for domains
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param country ISO_3166 country code in 2 letters
 * @param optional nil or *HistoricalApiDomainsGetOpts - Optional Parameters:
     * @param "Subcountry" (optional.String) -  state code
     * @param "FromDate" (optional.String) -  Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param "ToDate" (optional.String) -  Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param "UrlFilter" (optional.String) -  Filter answers to domains including a specified string
     * @param "Lines" (optional.Int32) -  Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more)
     * @param "Offset" (optional.Int32) -  Get paginated results from X offset
@return []Domains
*/

type HistoricalApiDomainsGetOpts struct {
    Subcountry optional.String
    FromDate optional.String
    ToDate optional.String
    UrlFilter optional.String
    Lines optional.Int32
    Offset optional.Int32
}

func (a *HistoricalApiService) DomainsGet(ctx context.Context, country string, localVarOptionals *HistoricalApiDomainsGetOpts) ([]Domains, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Get")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue []Domains
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/domains"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	localVarQueryParams.Add("country", parameterToString(country, ""))
	if localVarOptionals != nil && localVarOptionals.Subcountry.IsSet() {
		localVarQueryParams.Add("subcountry", parameterToString(localVarOptionals.Subcountry.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.FromDate.IsSet() {
		localVarQueryParams.Add("from_date", parameterToString(localVarOptionals.FromDate.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.ToDate.IsSet() {
		localVarQueryParams.Add("to_date", parameterToString(localVarOptionals.ToDate.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.UrlFilter.IsSet() {
		localVarQueryParams.Add("url_filter", parameterToString(localVarOptionals.UrlFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Lines.IsSet() {
		localVarQueryParams.Add("lines", parameterToString(localVarOptionals.Lines.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Offset.IsSet() {
		localVarQueryParams.Add("offset", parameterToString(localVarOptionals.Offset.Value(), ""))
	}
	// to determine the Content-Type header
	localVarHttpContentTypes := []string{}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		if localVarHttpResponse.StatusCode == 200 {
			var v []Domains
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}
/*
HistoricalApiService Get historical stats for entities
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param country ISO_3166 country code in 2 letters
 * @param optional nil or *HistoricalApiEntitiesGetOpts - Optional Parameters:
     * @param "Subcountry" (optional.String) -  state code
     * @param "FromDate" (optional.String) -  Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param "ToDate" (optional.String) -  Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param "KeywordFilter" (optional.String) -  Filter answers to entity names containing a particular keyword
     * @param "Lines" (optional.Int32) -  Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more)
     * @param "Offset" (optional.Int32) -  Get paginated results from X offset
@return []Entities
*/

type HistoricalApiEntitiesGetOpts struct {
    Subcountry optional.String
    FromDate optional.String
    ToDate optional.String
    KeywordFilter optional.String
    Lines optional.Int32
    Offset optional.Int32
}

func (a *HistoricalApiService) EntitiesGet(ctx context.Context, country string, localVarOptionals *HistoricalApiEntitiesGetOpts) ([]Entities, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Get")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue []Entities
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/entities"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	localVarQueryParams.Add("country", parameterToString(country, ""))
	if localVarOptionals != nil && localVarOptionals.Subcountry.IsSet() {
		localVarQueryParams.Add("subcountry", parameterToString(localVarOptionals.Subcountry.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.FromDate.IsSet() {
		localVarQueryParams.Add("from_date", parameterToString(localVarOptionals.FromDate.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.ToDate.IsSet() {
		localVarQueryParams.Add("to_date", parameterToString(localVarOptionals.ToDate.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.KeywordFilter.IsSet() {
		localVarQueryParams.Add("keyword_filter", parameterToString(localVarOptionals.KeywordFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Lines.IsSet() {
		localVarQueryParams.Add("lines", parameterToString(localVarOptionals.Lines.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Offset.IsSet() {
		localVarQueryParams.Add("offset", parameterToString(localVarOptionals.Offset.Value(), ""))
	}
	// to determine the Content-Type header
	localVarHttpContentTypes := []string{}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		if localVarHttpResponse.StatusCode == 200 {
			var v []Entities
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}
/*
HistoricalApiService Get history for entity
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param name entity exact name URL encoded
 * @param country ISO_3166 country code in 2 letters
 * @param optional nil or *HistoricalApiEntityGetOpts - Optional Parameters:
     * @param "Subcountry" (optional.String) -  state code
     * @param "FromDate" (optional.String) -  Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param "ToDate" (optional.String) -  Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
@return []Entity
*/

type HistoricalApiEntityGetOpts struct {
    Subcountry optional.String
    FromDate optional.String
    ToDate optional.String
}

func (a *HistoricalApiService) EntityGet(ctx context.Context, name string, country string, localVarOptionals *HistoricalApiEntityGetOpts) ([]Entity, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Get")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue []Entity
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/entity"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	localVarQueryParams.Add("name", parameterToString(name, ""))
	localVarQueryParams.Add("country", parameterToString(country, ""))
	if localVarOptionals != nil && localVarOptionals.Subcountry.IsSet() {
		localVarQueryParams.Add("subcountry", parameterToString(localVarOptionals.Subcountry.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.FromDate.IsSet() {
		localVarQueryParams.Add("from_date", parameterToString(localVarOptionals.FromDate.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.ToDate.IsSet() {
		localVarQueryParams.Add("to_date", parameterToString(localVarOptionals.ToDate.Value(), ""))
	}
	// to determine the Content-Type header
	localVarHttpContentTypes := []string{}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		if localVarHttpResponse.StatusCode == 200 {
			var v []Entity
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}
/*
HistoricalApiService Get page history for URL
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param url Fully qualified page url. URL needs to be URL encoded
 * @param country ISO_3166 country code in 2 letters
 * @param optional nil or *HistoricalApiPageGetOpts - Optional Parameters:
     * @param "Subcountry" (optional.String) -  state code
     * @param "FromDate" (optional.String) -  Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
     * @param "ToDate" (optional.String) -  Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
@return []Page
*/

type HistoricalApiPageGetOpts struct {
    Subcountry optional.String
    FromDate optional.String
    ToDate optional.String
}

func (a *HistoricalApiService) PageGet(ctx context.Context, url string, country string, localVarOptionals *HistoricalApiPageGetOpts) ([]Page, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Get")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue []Page
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/page"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	localVarQueryParams.Add("url", parameterToString(url, ""))
	localVarQueryParams.Add("country", parameterToString(country, ""))
	if localVarOptionals != nil && localVarOptionals.Subcountry.IsSet() {
		localVarQueryParams.Add("subcountry", parameterToString(localVarOptionals.Subcountry.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.FromDate.IsSet() {
		localVarQueryParams.Add("from_date", parameterToString(localVarOptionals.FromDate.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.ToDate.IsSet() {
		localVarQueryParams.Add("to_date", parameterToString(localVarOptionals.ToDate.Value(), ""))
	}
	// to determine the Content-Type header
	localVarHttpContentTypes := []string{}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		if localVarHttpResponse.StatusCode == 200 {
			var v []Page
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}
/*
HistoricalApiService Get historical stats for pages
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param optional nil or *HistoricalApiPagesGetOpts - Optional Parameters:
     * @param "FromDate" (optional.String) -  Datas from YYYY-MM-DD (if not provided, last 30 days)
     * @param "ToDate" (optional.String) -  Datas to YYYY-MM-DD (if not provided, last 30 days)
     * @param "Country" (optional.String) -  ISO_3166 country code in 2 letters (if not provided  worldwide)
     * @param "Subcountry" (optional.String) -  state code
     * @param "PresetFilter" (optional.Int32) -  Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories
     * @param "DomainFilter" (optional.String) -  Filter answers to pages of a designated domain name
     * @param "KeywordFilter" (optional.String) -  Filter answers to pages titles containing a particular keyword
     * @param "EntityFilter" (optional.String) -  Filter answers to pages with entities containing a particular keyword
     * @param "UrlFilter" (optional.String) -  Filter answers to pages URL including a specified string
     * @param "CategoryFilter" (optional.Int32) -  Filter answers to a specific page category
     * @param "LanguageFilter" (optional.String) -  Filter answers to pages in specific user language
     * @param "Lines" (optional.Int32) -  Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more)
     * @param "Offset" (optional.Int32) -  Get paginated results from X offset
@return []Pages
*/

type HistoricalApiPagesGetOpts struct {
    FromDate optional.String
    ToDate optional.String
    Country optional.String
    Subcountry optional.String
    PresetFilter optional.Int32
    DomainFilter optional.String
    KeywordFilter optional.String
    EntityFilter optional.String
    UrlFilter optional.String
    CategoryFilter optional.Int32
    LanguageFilter optional.String
    Lines optional.Int32
    Offset optional.Int32
}

func (a *HistoricalApiService) PagesGet(ctx context.Context, localVarOptionals *HistoricalApiPagesGetOpts) ([]Pages, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Get")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue []Pages
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/pages"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if localVarOptionals != nil && localVarOptionals.FromDate.IsSet() {
		localVarQueryParams.Add("from_date", parameterToString(localVarOptionals.FromDate.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.ToDate.IsSet() {
		localVarQueryParams.Add("to_date", parameterToString(localVarOptionals.ToDate.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Country.IsSet() {
		localVarQueryParams.Add("country", parameterToString(localVarOptionals.Country.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Subcountry.IsSet() {
		localVarQueryParams.Add("subcountry", parameterToString(localVarOptionals.Subcountry.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.PresetFilter.IsSet() {
		localVarQueryParams.Add("preset_filter", parameterToString(localVarOptionals.PresetFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.DomainFilter.IsSet() {
		localVarQueryParams.Add("domain_filter", parameterToString(localVarOptionals.DomainFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.KeywordFilter.IsSet() {
		localVarQueryParams.Add("keyword_filter", parameterToString(localVarOptionals.KeywordFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.EntityFilter.IsSet() {
		localVarQueryParams.Add("entity_filter", parameterToString(localVarOptionals.EntityFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.UrlFilter.IsSet() {
		localVarQueryParams.Add("url_filter", parameterToString(localVarOptionals.UrlFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.CategoryFilter.IsSet() {
		localVarQueryParams.Add("category_filter", parameterToString(localVarOptionals.CategoryFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.LanguageFilter.IsSet() {
		localVarQueryParams.Add("language_filter", parameterToString(localVarOptionals.LanguageFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Lines.IsSet() {
		localVarQueryParams.Add("lines", parameterToString(localVarOptionals.Lines.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Offset.IsSet() {
		localVarQueryParams.Add("offset", parameterToString(localVarOptionals.Offset.Value(), ""))
	}
	// to determine the Content-Type header
	localVarHttpContentTypes := []string{}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		if localVarHttpResponse.StatusCode == 200 {
			var v []Pages
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}
