
/*
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * API version: 0.9.250210
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package swagger

import (
	"context"
	"io/ioutil"
	"net/http"
	"net/url"
	"strings"
	"github.com/antihax/optional"
)

// Linger please
var (
	_ context.Context
)

type LiveApiService service
/*
LiveApiService Get livedata stats for categories
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param country ISO_3166 country code in 2 letters
 * @param optional nil or *LiveApiLivecategoriesGetOpts - Optional Parameters:
     * @param "Subcountry" (optional.String) -  state code
     * @param "Hours" (optional.Int32) -  Get results for last x hours
     * @param "KeywordFilter" (optional.String) -  Filter answers to category names containing a particular keyword
     * @param "LanguageFilter" (optional.String) -  Filter answers to pages in specific user language
     * @param "Lines" (optional.Int32) -  Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more)
     * @param "Offset" (optional.Int32) -  Get paginated results from X offset
@return []Categories
*/

type LiveApiLivecategoriesGetOpts struct {
    Subcountry optional.String
    Hours optional.Int32
    KeywordFilter optional.String
    LanguageFilter optional.String
    Lines optional.Int32
    Offset optional.Int32
}

func (a *LiveApiService) LivecategoriesGet(ctx context.Context, country string, localVarOptionals *LiveApiLivecategoriesGetOpts) ([]Categories, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Get")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue []Categories
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/livecategories"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	localVarQueryParams.Add("country", parameterToString(country, ""))
	if localVarOptionals != nil && localVarOptionals.Subcountry.IsSet() {
		localVarQueryParams.Add("subcountry", parameterToString(localVarOptionals.Subcountry.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Hours.IsSet() {
		localVarQueryParams.Add("hours", parameterToString(localVarOptionals.Hours.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.KeywordFilter.IsSet() {
		localVarQueryParams.Add("keyword_filter", parameterToString(localVarOptionals.KeywordFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.LanguageFilter.IsSet() {
		localVarQueryParams.Add("language_filter", parameterToString(localVarOptionals.LanguageFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Lines.IsSet() {
		localVarQueryParams.Add("lines", parameterToString(localVarOptionals.Lines.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Offset.IsSet() {
		localVarQueryParams.Add("offset", parameterToString(localVarOptionals.Offset.Value(), ""))
	}
	// to determine the Content-Type header
	localVarHttpContentTypes := []string{}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		if localVarHttpResponse.StatusCode == 200 {
			var v []Categories
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}
/*
LiveApiService Get livedata stats for domains
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param country ISO_3166 country code in 2 letters
 * @param optional nil or *LiveApiLivedomainsGetOpts - Optional Parameters:
     * @param "Subcountry" (optional.String) -  state code
     * @param "UrlFilter" (optional.String) -  Filter answers to domains including a specified string
     * @param "Hours" (optional.Int32) -  Get results for last x hours
     * @param "Lines" (optional.Int32) -  Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more)
     * @param "LanguageFilter" (optional.String) -  Filter answers to pages in specific user language
     * @param "Offset" (optional.Int32) -  Get paginated results from X offset
@return []Domains
*/

type LiveApiLivedomainsGetOpts struct {
    Subcountry optional.String
    UrlFilter optional.String
    Hours optional.Int32
    Lines optional.Int32
    LanguageFilter optional.String
    Offset optional.Int32
}

func (a *LiveApiService) LivedomainsGet(ctx context.Context, country string, localVarOptionals *LiveApiLivedomainsGetOpts) ([]Domains, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Get")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue []Domains
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/livedomains"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	localVarQueryParams.Add("country", parameterToString(country, ""))
	if localVarOptionals != nil && localVarOptionals.Subcountry.IsSet() {
		localVarQueryParams.Add("subcountry", parameterToString(localVarOptionals.Subcountry.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.UrlFilter.IsSet() {
		localVarQueryParams.Add("url_filter", parameterToString(localVarOptionals.UrlFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Hours.IsSet() {
		localVarQueryParams.Add("hours", parameterToString(localVarOptionals.Hours.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Lines.IsSet() {
		localVarQueryParams.Add("lines", parameterToString(localVarOptionals.Lines.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.LanguageFilter.IsSet() {
		localVarQueryParams.Add("language_filter", parameterToString(localVarOptionals.LanguageFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Offset.IsSet() {
		localVarQueryParams.Add("offset", parameterToString(localVarOptionals.Offset.Value(), ""))
	}
	// to determine the Content-Type header
	localVarHttpContentTypes := []string{}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		if localVarHttpResponse.StatusCode == 200 {
			var v []Domains
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}
/*
LiveApiService Get livedata stats for entities
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param country ISO_3166 country code in 2 letters
 * @param optional nil or *LiveApiLiveentitiesGetOpts - Optional Parameters:
     * @param "Subcountry" (optional.String) -  state code
     * @param "Hours" (optional.Int32) -  Get results for last x hours
     * @param "KeywordFilter" (optional.String) -  Filter answers to entity names containing a particular keyword
     * @param "CategoryFilter" (optional.Int32) -  Filter answers to pages of a designated category id
     * @param "LanguageFilter" (optional.String) -  Filter answers to pages in specific user language
     * @param "DomainFilter" (optional.String) -  Filter answers to pages of a designated domain name
     * @param "Lines" (optional.Int32) -  Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more)
     * @param "Offset" (optional.Int32) -  Get paginated results from X offset
@return []Entities
*/

type LiveApiLiveentitiesGetOpts struct {
    Subcountry optional.String
    Hours optional.Int32
    KeywordFilter optional.String
    CategoryFilter optional.Int32
    LanguageFilter optional.String
    DomainFilter optional.String
    Lines optional.Int32
    Offset optional.Int32
}

func (a *LiveApiService) LiveentitiesGet(ctx context.Context, country string, localVarOptionals *LiveApiLiveentitiesGetOpts) ([]Entities, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Get")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue []Entities
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/liveentities"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	localVarQueryParams.Add("country", parameterToString(country, ""))
	if localVarOptionals != nil && localVarOptionals.Subcountry.IsSet() {
		localVarQueryParams.Add("subcountry", parameterToString(localVarOptionals.Subcountry.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Hours.IsSet() {
		localVarQueryParams.Add("hours", parameterToString(localVarOptionals.Hours.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.KeywordFilter.IsSet() {
		localVarQueryParams.Add("keyword_filter", parameterToString(localVarOptionals.KeywordFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.CategoryFilter.IsSet() {
		localVarQueryParams.Add("category_filter", parameterToString(localVarOptionals.CategoryFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.LanguageFilter.IsSet() {
		localVarQueryParams.Add("language_filter", parameterToString(localVarOptionals.LanguageFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.DomainFilter.IsSet() {
		localVarQueryParams.Add("domain_filter", parameterToString(localVarOptionals.DomainFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Lines.IsSet() {
		localVarQueryParams.Add("lines", parameterToString(localVarOptionals.Lines.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Offset.IsSet() {
		localVarQueryParams.Add("offset", parameterToString(localVarOptionals.Offset.Value(), ""))
	}
	// to determine the Content-Type header
	localVarHttpContentTypes := []string{}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		if localVarHttpResponse.StatusCode == 200 {
			var v []Entities
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}
/*
LiveApiService Get livedata stats for pages
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param country ISO_3166 country code in 2 letters
 * @param optional nil or *LiveApiLivepagesGetOpts - Optional Parameters:
     * @param "Subcountry" (optional.String) -  state code
     * @param "Hours" (optional.Int32) -  Get results for last x hours
     * @param "PresetFilter" (optional.Int32) -  Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories
     * @param "OnlyNew" (optional.Int32) -  Get only pages first seen in the reporting period if set on 1
     * @param "DomainFilter" (optional.String) -  Filter answers to pages of a designated domain name
     * @param "KeywordFilter" (optional.String) -  Filter answers to pages titles containing a particular keyword
     * @param "EntityFilter" (optional.String) -  Filter answers to pages with entities containing a particular keyword
     * @param "UrlFilter" (optional.String) -  Filter answers to pages URL including a specified string
     * @param "CategoryFilter" (optional.Int32) -  Filter answers to pages of a designated category id
     * @param "LanguageFilter" (optional.String) -  Filter answers to pages in specific user language
     * @param "Lines" (optional.Int32) -  Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more)
     * @param "Offset" (optional.Int32) -  Get paginated results from X offset
@return []Pages
*/

type LiveApiLivepagesGetOpts struct {
    Subcountry optional.String
    Hours optional.Int32
    PresetFilter optional.Int32
    OnlyNew optional.Int32
    DomainFilter optional.String
    KeywordFilter optional.String
    EntityFilter optional.String
    UrlFilter optional.String
    CategoryFilter optional.Int32
    LanguageFilter optional.String
    Lines optional.Int32
    Offset optional.Int32
}

func (a *LiveApiService) LivepagesGet(ctx context.Context, country string, localVarOptionals *LiveApiLivepagesGetOpts) ([]Pages, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Get")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue []Pages
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/livepages"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	localVarQueryParams.Add("country", parameterToString(country, ""))
	if localVarOptionals != nil && localVarOptionals.Subcountry.IsSet() {
		localVarQueryParams.Add("subcountry", parameterToString(localVarOptionals.Subcountry.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Hours.IsSet() {
		localVarQueryParams.Add("hours", parameterToString(localVarOptionals.Hours.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.PresetFilter.IsSet() {
		localVarQueryParams.Add("preset_filter", parameterToString(localVarOptionals.PresetFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.OnlyNew.IsSet() {
		localVarQueryParams.Add("only_new", parameterToString(localVarOptionals.OnlyNew.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.DomainFilter.IsSet() {
		localVarQueryParams.Add("domain_filter", parameterToString(localVarOptionals.DomainFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.KeywordFilter.IsSet() {
		localVarQueryParams.Add("keyword_filter", parameterToString(localVarOptionals.KeywordFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.EntityFilter.IsSet() {
		localVarQueryParams.Add("entity_filter", parameterToString(localVarOptionals.EntityFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.UrlFilter.IsSet() {
		localVarQueryParams.Add("url_filter", parameterToString(localVarOptionals.UrlFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.CategoryFilter.IsSet() {
		localVarQueryParams.Add("category_filter", parameterToString(localVarOptionals.CategoryFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.LanguageFilter.IsSet() {
		localVarQueryParams.Add("language_filter", parameterToString(localVarOptionals.LanguageFilter.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Lines.IsSet() {
		localVarQueryParams.Add("lines", parameterToString(localVarOptionals.Lines.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Offset.IsSet() {
		localVarQueryParams.Add("offset", parameterToString(localVarOptionals.Offset.Value(), ""))
	}
	// to determine the Content-Type header
	localVarHttpContentTypes := []string{}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		if localVarHttpResponse.StatusCode == 200 {
			var v []Pages
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}
