# {{classname}}

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**AlertsChangeGet**](AlertsApi.md#AlertsChangeGet) | **Get** /alerts_change | Edit or insert new alert
[**AlertsDeleteGet**](AlertsApi.md#AlertsDeleteGet) | **Get** /alerts_delete | Permanently delete the alert
[**AlertsGet**](AlertsApi.md#AlertsGet) | **Get** /alerts | Get alerts for user account

# **AlertsChangeGet**
> []Domains AlertsChangeGet(ctx, id, alertname, activated, type_, channel, recipient, optional)
Edit or insert new alert

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **id** | **string**| ID of the alert to edit ; if adding a new one leave blank | 
  **alertname** | **string**| Name of the alert | 
  **activated** | **bool**| Should the alert be activated or not | 
  **type_** | **int32**| Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category | 
  **channel** | **int32**| 1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON | 
  **recipient** | **string**| Email address of recipient or webhook for Slack/Gchat or JSON endpoint | 
 **optional** | ***AlertsApiAlertsChangeGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a AlertsApiAlertsChangeGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------






 **param1** | **optional.String**| Parameter 1 (meaning changes with alert type) | 
 **param2** | **optional.String**| Parameter 2 (meaning changes with alert type) | 
 **param3** | **optional.String**| Parameter 3 (meaning changes with alert type) | 
 **param4** | **optional.String**| Parameter 4 (meaning changes with alert type) | 
 **param5** | **optional.String**| Parameter 5 (meaning changes with alert type) | 
 **param6** | **optional.String**| Parameter 6 (meaning changes with alert type) | 

### Return type

[**[]Domains**](Domains.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **AlertsDeleteGet**
> []TransactionInfo AlertsDeleteGet(ctx, id)
Permanently delete the alert

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **id** | **string**| alert id to delete | 

### Return type

[**[]TransactionInfo**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **AlertsGet**
> []Alerts AlertsGet(ctx, )
Get alerts for user account

### Required Parameters
This endpoint does not need any parameter.

### Return type

[**[]Alerts**](Alerts.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

