# {{classname}}

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**FavsAddGet**](FavsApi.md#FavsAddGet) | **Get** /favs_add | Create a new fav
[**FavsDeleteGet**](FavsApi.md#FavsDeleteGet) | **Get** /favs_delete | Permanently delete the fav
[**FavsGet**](FavsApi.md#FavsGet) | **Get** /favs | Get favorites
[**FavsUpdateGet**](FavsApi.md#FavsUpdateGet) | **Get** /favs_update | Update the fav

# **FavsAddGet**
> []TransactionInfo FavsAddGet(ctx, optional)
Create a new fav

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
 **optional** | ***FavsApiFavsAddGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a FavsApiFavsAddGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **optional.String**| Name of the fav. | 
 **action** | **optional.String**| Action to be opened. | 
 **parameters** | **optional.String**| Action&#x27;s parameters encoded in JSON. | 

### Return type

[**[]TransactionInfo**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **FavsDeleteGet**
> []TransactionInfo FavsDeleteGet(ctx, optional)
Permanently delete the fav

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
 **optional** | ***FavsApiFavsDeleteGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a FavsApiFavsDeleteGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **optional.String**| ID of the fav to delete. | 

### Return type

[**[]TransactionInfo**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **FavsGet**
> []Favs FavsGet(ctx, optional)
Get favorites

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
 **optional** | ***FavsApiFavsGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a FavsApiFavsGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **optional.String**| ID of the requested fav. ignore or set to 0 to get the full favs list | 

### Return type

[**[]Favs**](Favs.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **FavsUpdateGet**
> []TransactionInfo FavsUpdateGet(ctx, id, optional)
Update the fav

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **id** | **string**| ID of the fav that should be edited | 
 **optional** | ***FavsApiFavsUpdateGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a FavsApiFavsUpdateGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **name** | **optional.String**| Name of the fav. | 
 **action** | **optional.String**| Action to be opened. | 
 **parameters** | **optional.String**| Action&#x27;s parameters encoded in JSON. | 
 **scheduled** | **optional.Int32**| 0 if not scheduled, else x in hours | 
 **scheduledto** | **optional.String**| email address of the recipient of this report | 

### Return type

[**[]TransactionInfo**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

