# {{classname}}

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CategoriesGet**](HistoricalApi.md#CategoriesGet) | **Get** /categories | Get historical stats for categories
[**CategoryGet**](HistoricalApi.md#CategoryGet) | **Get** /category | Get history for category ID
[**DomainGet**](HistoricalApi.md#DomainGet) | **Get** /domain | Get history for domain name
[**DomainsGet**](HistoricalApi.md#DomainsGet) | **Get** /domains | Get historical stats for domains
[**EntitiesGet**](HistoricalApi.md#EntitiesGet) | **Get** /entities | Get historical stats for entities
[**EntityGet**](HistoricalApi.md#EntityGet) | **Get** /entity | Get history for entity
[**PageGet**](HistoricalApi.md#PageGet) | **Get** /page | Get page history for URL
[**PagesGet**](HistoricalApi.md#PagesGet) | **Get** /pages | Get historical stats for pages

# **CategoriesGet**
> []Categories CategoriesGet(ctx, country, optional)
Get historical stats for categories

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **country** | **string**| ISO_3166 country code in 2 letters | 
 **optional** | ***HistoricalApiCategoriesGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a HistoricalApiCategoriesGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **subcountry** | **optional.String**| state code | 
 **fromDate** | **optional.String**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | 
 **toDate** | **optional.String**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | 
 **keywordFilter** | **optional.String**| Filter answers to cateogry names containing a particular keyword | 
 **lines** | **optional.Int32**| Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) | [default to 50]
 **offset** | **optional.Int32**| Get paginated results from X offset | [default to 0]

### Return type

[**[]Categories**](Categories.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **CategoryGet**
> []Category CategoryGet(ctx, id, country, optional)
Get history for category ID

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **id** | **string**| category id | 
  **country** | **string**| ISO_3166 country code in 2 letters | 
 **optional** | ***HistoricalApiCategoryGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a HistoricalApiCategoryGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------


 **subcountry** | **optional.String**| state code | 
 **fromDate** | **optional.String**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | 
 **toDate** | **optional.String**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | 

### Return type

[**[]Category**](Category.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **DomainGet**
> []Domain DomainGet(ctx, domain, country, optional)
Get history for domain name

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **domain** | **string**| domain name (no subdomain allowed) | 
  **country** | **string**| ISO_3166 country code in 2 letters | 
 **optional** | ***HistoricalApiDomainGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a HistoricalApiDomainGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------


 **subcountry** | **optional.String**| state code | 
 **fromDate** | **optional.String**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | 
 **toDate** | **optional.String**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | 

### Return type

[**[]Domain**](Domain.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **DomainsGet**
> []Domains DomainsGet(ctx, country, optional)
Get historical stats for domains

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **country** | **string**| ISO_3166 country code in 2 letters | 
 **optional** | ***HistoricalApiDomainsGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a HistoricalApiDomainsGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **subcountry** | **optional.String**| state code | 
 **fromDate** | **optional.String**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | 
 **toDate** | **optional.String**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | 
 **urlFilter** | **optional.String**| Filter answers to domains including a specified string | 
 **lines** | **optional.Int32**| Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) | [default to 50]
 **offset** | **optional.Int32**| Get paginated results from X offset | [default to 0]

### Return type

[**[]Domains**](Domains.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **EntitiesGet**
> []Entities EntitiesGet(ctx, country, optional)
Get historical stats for entities

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **country** | **string**| ISO_3166 country code in 2 letters | 
 **optional** | ***HistoricalApiEntitiesGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a HistoricalApiEntitiesGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **subcountry** | **optional.String**| state code | 
 **fromDate** | **optional.String**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | 
 **toDate** | **optional.String**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | 
 **keywordFilter** | **optional.String**| Filter answers to entity names containing a particular keyword | 
 **lines** | **optional.Int32**| Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) | [default to 50]
 **offset** | **optional.Int32**| Get paginated results from X offset | [default to 0]

### Return type

[**[]Entities**](Entities.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **EntityGet**
> []Entity EntityGet(ctx, name, country, optional)
Get history for entity

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **name** | **string**| entity exact name URL encoded | 
  **country** | **string**| ISO_3166 country code in 2 letters | 
 **optional** | ***HistoricalApiEntityGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a HistoricalApiEntityGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------


 **subcountry** | **optional.String**| state code | 
 **fromDate** | **optional.String**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | 
 **toDate** | **optional.String**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | 

### Return type

[**[]Entity**](Entity.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **PageGet**
> []Page PageGet(ctx, url, country, optional)
Get page history for URL

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **url** | **string**| Fully qualified page url. URL needs to be URL encoded | 
  **country** | **string**| ISO_3166 country code in 2 letters | 
 **optional** | ***HistoricalApiPageGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a HistoricalApiPageGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------


 **subcountry** | **optional.String**| state code | 
 **fromDate** | **optional.String**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | 
 **toDate** | **optional.String**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | 

### Return type

[**[]Page**](Page.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **PagesGet**
> []Pages PagesGet(ctx, optional)
Get historical stats for pages

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
 **optional** | ***HistoricalApiPagesGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a HistoricalApiPagesGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fromDate** | **optional.String**| Datas from YYYY-MM-DD (if not provided, last 30 days) | 
 **toDate** | **optional.String**| Datas to YYYY-MM-DD (if not provided, last 30 days) | 
 **country** | **optional.String**| ISO_3166 country code in 2 letters (if not provided  worldwide) | 
 **subcountry** | **optional.String**| state code | 
 **presetFilter** | **optional.Int32**| Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories | 
 **domainFilter** | **optional.String**| Filter answers to pages of a designated domain name | 
 **keywordFilter** | **optional.String**| Filter answers to pages titles containing a particular keyword | 
 **entityFilter** | **optional.String**| Filter answers to pages with entities containing a particular keyword | 
 **urlFilter** | **optional.String**| Filter answers to pages URL including a specified string | 
 **categoryFilter** | **optional.Int32**| Filter answers to a specific page category | 
 **languageFilter** | **optional.String**| Filter answers to pages in specific user language | 
 **lines** | **optional.Int32**| Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) | [default to 50]
 **offset** | **optional.Int32**| Get paginated results from X offset | [default to 0]

### Return type

[**[]Pages**](Pages.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

