# {{classname}}

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**LivecategoriesGet**](LiveApi.md#LivecategoriesGet) | **Get** /livecategories | Get livedata stats for categories
[**LivedomainsGet**](LiveApi.md#LivedomainsGet) | **Get** /livedomains | Get livedata stats for domains
[**LiveentitiesGet**](LiveApi.md#LiveentitiesGet) | **Get** /liveentities | Get livedata stats for entities
[**LivepagesGet**](LiveApi.md#LivepagesGet) | **Get** /livepages | Get livedata stats for pages

# **LivecategoriesGet**
> []Categories LivecategoriesGet(ctx, country, optional)
Get livedata stats for categories

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **country** | **string**| ISO_3166 country code in 2 letters | 
 **optional** | ***LiveApiLivecategoriesGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a LiveApiLivecategoriesGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **subcountry** | **optional.String**| state code | 
 **hours** | **optional.Int32**| Get results for last x hours | 
 **keywordFilter** | **optional.String**| Filter answers to category names containing a particular keyword | 
 **languageFilter** | **optional.String**| Filter answers to pages in specific user language | 
 **lines** | **optional.Int32**| Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) | [default to 50]
 **offset** | **optional.Int32**| Get paginated results from X offset | [default to 0]

### Return type

[**[]Categories**](Categories.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **LivedomainsGet**
> []Domains LivedomainsGet(ctx, country, optional)
Get livedata stats for domains

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **country** | **string**| ISO_3166 country code in 2 letters | 
 **optional** | ***LiveApiLivedomainsGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a LiveApiLivedomainsGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **subcountry** | **optional.String**| state code | 
 **urlFilter** | **optional.String**| Filter answers to domains including a specified string | 
 **hours** | **optional.Int32**| Get results for last x hours | 
 **lines** | **optional.Int32**| Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) | [default to 50]
 **languageFilter** | **optional.String**| Filter answers to pages in specific user language | 
 **offset** | **optional.Int32**| Get paginated results from X offset | [default to 0]

### Return type

[**[]Domains**](Domains.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **LiveentitiesGet**
> []Entities LiveentitiesGet(ctx, country, optional)
Get livedata stats for entities

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **country** | **string**| ISO_3166 country code in 2 letters | 
 **optional** | ***LiveApiLiveentitiesGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a LiveApiLiveentitiesGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **subcountry** | **optional.String**| state code | 
 **hours** | **optional.Int32**| Get results for last x hours | 
 **keywordFilter** | **optional.String**| Filter answers to entity names containing a particular keyword | 
 **categoryFilter** | **optional.Int32**| Filter answers to pages of a designated category id | 
 **languageFilter** | **optional.String**| Filter answers to pages in specific user language | 
 **domainFilter** | **optional.String**| Filter answers to pages of a designated domain name | 
 **lines** | **optional.Int32**| Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) | [default to 50]
 **offset** | **optional.Int32**| Get paginated results from X offset | [default to 0]

### Return type

[**[]Entities**](Entities.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **LivepagesGet**
> []Pages LivepagesGet(ctx, country, optional)
Get livedata stats for pages

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **country** | **string**| ISO_3166 country code in 2 letters | 
 **optional** | ***LiveApiLivepagesGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a LiveApiLivepagesGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **subcountry** | **optional.String**| state code | 
 **hours** | **optional.Int32**| Get results for last x hours | 
 **presetFilter** | **optional.Int32**| Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories | 
 **onlyNew** | **optional.Int32**| Get only pages first seen in the reporting period if set on 1 | [default to 0]
 **domainFilter** | **optional.String**| Filter answers to pages of a designated domain name | 
 **keywordFilter** | **optional.String**| Filter answers to pages titles containing a particular keyword | 
 **entityFilter** | **optional.String**| Filter answers to pages with entities containing a particular keyword | 
 **urlFilter** | **optional.String**| Filter answers to pages URL including a specified string | 
 **categoryFilter** | **optional.Int32**| Filter answers to pages of a designated category id | 
 **languageFilter** | **optional.String**| Filter answers to pages in specific user language | 
 **lines** | **optional.Int32**| Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) | [default to 50]
 **offset** | **optional.Int32**| Get paginated results from X offset | [default to 0]

### Return type

[**[]Pages**](Pages.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

