# {{classname}}

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**UserCountriesChangeGet**](UserApi.md#UserCountriesChangeGet) | **Get** /user_countries_change | Change user&#x27;s activated countries
[**UserCustidChangeGet**](UserApi.md#UserCustidChangeGet) | **Get** /user_custid_change | Change user customer id. This function is system reserved
[**UserDeleteGet**](UserApi.md#UserDeleteGet) | **Get** /user_delete | Permanently delete the user
[**UserDetailsChangeGet**](UserApi.md#UserDetailsChangeGet) | **Get** /user_details_change | Change user details
[**UserLoginGet**](UserApi.md#UserLoginGet) | **Get** /user_login | Login user with his credentials
[**UserMessagesGet**](UserApi.md#UserMessagesGet) | **Get** /user_messages | Get messages for user
[**UserPasswordChangeGet**](UserApi.md#UserPasswordChangeGet) | **Get** /user_password_change | Change user password
[**UserPasswordResetGet**](UserApi.md#UserPasswordResetGet) | **Get** /user_password_reset | Reset user password
[**UserRefreshSubscriptionGet**](UserApi.md#UserRefreshSubscriptionGet) | **Get** /user_refresh_subscription | Refresh user rights with his Customer ID. This function is system reserved
[**UserRegisterGet**](UserApi.md#UserRegisterGet) | **Get** /user_register | Login user with his credentials

# **UserCountriesChangeGet**
> []TransactionInfo UserCountriesChangeGet(ctx, countries, categories)
Change user's activated countries

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **countries** | **string**| json encoded string representing countries to activate | 
  **categories** | **string**| json encoded string representing categories ID to activate | 

### Return type

[**[]TransactionInfo**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UserCustidChangeGet**
> []TransactionInfo UserCustidChangeGet(ctx, custid)
Change user customer id. This function is system reserved

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **custid** | **string**| new customer id for user | 

### Return type

[**[]TransactionInfo**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UserDeleteGet**
> []TransactionInfo UserDeleteGet(ctx, )
Permanently delete the user

### Required Parameters
This endpoint does not need any parameter.

### Return type

[**[]TransactionInfo**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UserDetailsChangeGet**
> []TransactionInfo UserDetailsChangeGet(ctx, email, fname, lname, optional)
Change user details

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **email** | **string**| new email address for user | 
  **fname** | **string**| new firstname for user | 
  **lname** | **string**| new lastname for user | 
 **optional** | ***UserApiUserDetailsChangeGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a UserApiUserDetailsChangeGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------



 **translation** | **optional.String**| update the translation settings for user original (will show original titles) | english (will show titles translated in english) | 

### Return type

[**[]TransactionInfo**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UserLoginGet**
> []UserInfo UserLoginGet(ctx, email, password, optional)
Login user with his credentials

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **email** | **string**| email address for user | 
  **password** | **string**| password for user | 
 **optional** | ***UserApiUserLoginGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a UserApiUserLoginGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------


 **pin** | **optional.Int32**| pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; | 

### Return type

[**[]UserInfo**](UserInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UserMessagesGet**
> []Message UserMessagesGet(ctx, optional)
Get messages for user

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
 **optional** | ***UserApiUserMessagesGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a UserApiUserMessagesGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **message** | **optional.Int32**| ID of the requested message. 0 to get the full message list | 

### Return type

[**[]Message**](Message.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UserPasswordChangeGet**
> []TransactionInfo UserPasswordChangeGet(ctx, email, password, newpassword)
Change user password

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **email** | **string**| email address for user | 
  **password** | **string**| current password for user | 
  **newpassword** | **string**| new password to set up for user | 

### Return type

[**[]TransactionInfo**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UserPasswordResetGet**
> []TransactionInfo UserPasswordResetGet(ctx, email)
Reset user password

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **email** | **string**| email address for user | 

### Return type

[**[]TransactionInfo**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UserRefreshSubscriptionGet**
> []UserInfo UserRefreshSubscriptionGet(ctx, custid)
Refresh user rights with his Customer ID. This function is system reserved

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **custid** | **string**| Customer ID for the user | 

### Return type

[**[]UserInfo**](UserInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UserRegisterGet**
> []UserInfo UserRegisterGet(ctx, email, password, fname, lname, optional)
Login user with his credentials

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **email** | **string**| email address for user | 
  **password** | **string**| password for user | 
  **fname** | **string**| new firstname for user | 
  **lname** | **string**| new lastname for user | 
 **optional** | ***UserApiUserRegisterGetOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a UserApiUserRegisterGetOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------




 **referrer** | **optional.String**| referrer for this user. should be urlencoded | 

### Return type

[**[]UserInfo**](UserInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

